
 //----------------------------------------------------------*---------------
#include <stdlib.h> 
#include <LiquidCrystal.h>                                   // для общения с LCD
#include <OneWire.h>                                         // для обмена по 1-wire
#include <EEPROM.h>                                          // для работы с EEPROM
#include <avr/wdt.h>                                         // для работы собачьего таймера

#define Hi(Int)  (char) (Int>>8)                             // мощность тэна
#define Low(Int) (char) (Int)                                // мощность тэна

/*union
{
float f;
unsigned char buf[4];
}tmp;
//tmp.f = 50.25;*/

boolean butRel=1;                                            // отпущена ли сейчас кнопка 
boolean braga;                                               // режим брага/спирт (брага по умолчанию)
boolean avto  = false;                                       // режим автомат ручное (ручное по умолчанию)
boolean golova_bool;                                         // признак отбора голов
boolean stop_;                                               // режим тестирования при полном останове
boolean formula;                                             // применение формулы


unsigned char c_comand[4];                                   // команда для порта

byte Tt;                                                     // разность температур
byte nc;                                                     // для команд СОМ порта
byte cikl_CC;                                                // количество циклов сырца за год 
byte cikl_BR;                                                // количество циклов браги за год 
byte butPin = 0;                                             // пин входа кнопок
byte butPush = 0;                                            // код нажатой кнопки
//byte butsens=10;                                             // чувствительность кнопок
byte buzzer = 3;                                             // выход динамика
byte edit_mode = 0;                                          // разрешаем менять уставки
byte i;                                                      // просто счетчик
byte n;                                                      // просто счетчик
byte m=0;                                                    // просто счетчик
byte t=0;                                                    // просто счетчик
byte tt;                                                     // счётчик циклов для PID
byte n_zad;                                                  // счётчик для подсчёта задания
byte Tdata[40];                                              // седьмое значение - % нагрузки
byte state = 0;                                              // статус 0 - был выключен 1 - не был включен
byte edit_position = 3;
byte cur_poz = 1;
byte data[9];                                                // массив для хранения данных принятых от датчика
byte TotalDS=0;                                              // число найденых датчиков на линии
byte power;                                                  // мощность тэна в единицах от 1 до 20 
byte power_real = 45;                                        // текущаа мощность тэна в единицах от 1 до 20
byte power_com;                                              // мощность тэна в единицах от 1 до 20 для порта
byte golova;                                                 // счётчик-антидребезг поплавка голов
byte addr[6][8] = {{0,0,0,0,0,0,0,0  },                      // двумерный массив адресов датчиков
                   {0,0,0,0,0,0,0,0  },
                   {0,0,0,0,0,0,0,0  },                      // 4 адреса по 8 байт
                   {0,0,0,0,0,0,0,0  },
                   {0,0,0,0,0,0,0,0  },                   
                   {0,0,0,0,0,0,0,0  }};

int val;                                                     // знач. АЦП при нажатой кнопке
int butsens=10;                                             // чувствительность кнопок
int scel=1,cel=2,des=3;
int razr = scel;

//int butval[6]={0,UP,LEFT,SELECT,RIGTH,DOWN};                 // коды кнопок: 1 - вверх, 2 - влево, 3 - ок, 4 - вправо, 5 вниз 
//int butval[6]={0,130,472,712,0,303};  
int butval[6];

int cikl;

float T[] ={0,0,0,0,0};                                      // температуры T[0]-т.куб, T[1]-т.охладителя, T[2]-т.колонна, T[3]-т.дефлегматор, T[4]-т.наружный воздух
float Tp[]={0,0,0,0,0};                                      // переменная для хранения температуры с прошлого замера
float U[]={0,50.0,0};                                        // переменная для хранения уставок U[0]-т.браги, U[1]-т.охладителя, U[2]-т.сырца
float delta_T;                                               // разница температур дефлегматора
float T_mem;                                                 // предыдущая температура дельты
float ustavka_t;                                             // хранит уставку Т. для окончания процесса определённого режима
//--------PID----------------------------------------
float E, D, PID_;                                            // составляющие пропорциональный, интэгральный, дифференциальный
float I = -2000;
float zadanie;                                               // задание регулятору
float zadanie_com;                                           // задание в порт
//float Kp = 6, Ki = 3, Kd = 50;                               // коэффициенты пропорциональный, интэгральный, дифференциальный
byte Kp, Ki , Kd;                                            // коэффициенты пропорциональный, интэгральный, дифференциальный
float Ki_, Kp_, Kd_;
float Pt, PE;
float power_float;
//--------PID----------------------------------------
OneWire  ds(2);                                              // на этот пин подключена линия DQ 1-wire
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);                         // инициализация дисплея
//void(* resetFunc) (void) = 0;                                // програмный ресет
div_t x;                                                     // функция разделения float-byte
//----------------------------------------------------------*--------------- ------------------------------------------------------------
/* распределение адресов EEPROM 
 задание                    60,61,62
 датчики DS18B20            0-40        уставка Т.куба браги  125,126,127  
 уставка Т.куба сырца       132,133,134
 статус(state)              129         нагрузка        130
 режим перегона брага\спирт 140         статус работы   150 
 кол-во циклов  браги       152         сырца           154
 признак отбора голов       156
 Kp                         158         Kd              162
 Ki                         160
 formula_cc                 168    formula_br           166
 тип платы индикатора       200
 */
 
 /*
  byte Tdata40];           

 Tdata[0]- Tdata[11] 				// формирование температур датчиков для порта
                               		
 Tdata[13] Tdata[14]				Kd_коэффициенты ПИД в порт
 Tdata[15] = x.quot;				ustavka_t
 Tdata[16] = x.rem;				ustavka_t
 Tdata[17] = 0;                                 // мощность тэна в порт
 Tdata[18] = x.quot;				zadanie_com
 Tdata[19] = x.rem; 				zadanie_com
 Tdata[20] = 0;                                 // режим форсаж в порт
 Tdata[21] = golova_bool;                       // режим отбор голов в порт 
 Tdata[22] = braga;                             // брага-спирт
 Tdata[23] = formula;                           // применение формулы 
 Tdata[24] = cikl_CC;                           // количество циклов сырца за год
 Tdata[25] = cikl_BR;                           // количество циклов браги за год 
 Tdata[26] Tdata[27]                            // Kp_ коэффициенты ПИД в порт
 Tdata[28] Tdata[29]				// Ki_
 Tdata[30] = state;                             // признак окончания процесса
 Tdata[31] = Kp                                 // настроечные коэффициенты ПИД
 Tdata[32] = Ki                                 // настроечные коэффициенты ПИД
 Tdata[33] = Kd                                 // настроечные коэффициенты ПИД 

 Serial.write(Tdata,40);                        // массив данных в порт  
 */
void setup()         
{
// EEPROM.write(152,100);  EEPROM.write(154,50);              // обнуление счётчиков кол-ва перегонов
// EEPROM.write(158,15); EEPROM.write(160,25); EEPROM.write(162,10); 
// EEPROM.write(200,100);                                     // плата нового сам.аппарата
// EEPROM.write(200,101);                                     // плата лабораторная
 if(EEPROM.read(200)==100)                                    // выбор типа платы индикатора
  {
    butval[1]=130;                                            // UP     1 - вверх
    butval[2]=472;                                            // LEFT   2 - влево
    butval[3]=712;                                            // SELECT 3 - ок
    butval[4]=0;                                              // RIGTH  4 - вправо
    butval[5]=303;                                            // DOWN   5 - вниз
 }
 else if(EEPROM.read(200)==101)
  {
    butval[1]=102;                                             // UP     1 - вверх
    butval[2]=416;                                            // LEFT   2 - влево
    butval[3]=646;                                            // SELECT 3 - ок
    butval[4]=0;                                              // RIGTH  4 - вправо
    butval[5]=262;                                            // DOWN   5 - вниз
  };  
  
  lcd.clear();                                                // очищаем дисплей
  wdt_enable(WDTO_8S);                                        // сторожевой таймер на 8 секунд

  // переинициализация таймера 1 для получения нужной частоты ШИМ  // Timer/Counter 1 initialization
  // Clock source: System Clock                                    // Clock value: 15,625 kHz
  // Mode: Fast PWM top=OCR1A                                      // OC1A output: Discon.
  // OC1B output: Non-Inv.                                         // Noise Canceler: Off
  // Input Capture on Falling Edge                                 // Timer1 Overflow Interrupt: Off
  // Input Capture Interrupt: Off                                  // Compare A Match Interrupt: Off
  // Compare B Match Interrupt: Off
  TCCR1A=0x23; TCCR1B=0x1D; TCNT1H=0x00; TCNT1L=0x00; ICR1H=0x00; ICR1L=0x00; OCR1AH=0x7A; OCR1AL=0x08;
  OCR1BH=Hi(0); OCR1BL=Low(0);                               // мощность тэна  "0" 
//----------------------------------------------------------*---------------------------------------------------------------------------
  pinMode(10, OUTPUT);                                       // 10 вывод управление рабочим тэном
  pinMode(11, OUTPUT);                                       // 11 вывод управление тэном форсаж
  pinMode(12, OUTPUT);                                       // 12 включение клапана отбора голов
  pinMode(15, INPUT);                                        // аналоговый вход как цифровой вход для хвостов(A1)

  digitalWrite(15, HIGH);                                    // подтягивающий резистор
  digitalWrite(11, LOW);                                     // выключаем форсаж

  Serial.begin(9600);                                        // последовательный порт для отладки и bluetoth
  lcd.begin(2, 16);                                          // включаем дисплей
  state = EEPROM.read(129);                                  // чтение статуса из ЕЕПРОМ
  Kp = EEPROM.read(158); 
  Ki = EEPROM.read(160); 
  Kd = EEPROM.read(162);  
  avto =  EEPROM.read(150);                                  // чтение состояния автомат\ручное из ЕЕПРОМ
  braga = boolean(EEPROM.read(164));                         // чтение режима из ЕЕПРОМ брага/спирт
  cikl_CC = EEPROM.read(154);
  cikl_BR = EEPROM.read(152);
  if(braga) formula = EEPROM.read(166);                      // применение формулы 
  else      formula = EEPROM.read(168);
  
  if (analogRead(0) < 1000)                                  // выбор режима работы после перегрузки
   {
      button ();  
      if(butPush != 0){lcd.clear();};
      while(analogRead(butPin)<1000);                        // ждём отпускания кнопки
      switch(butPush)
       {
          case 4: statistik_viuver();     break;             // вправо режим просмотра статистики            
          case 1: setup_DS18B20();        break;             // вверх  апарат в режиме настройки датчиков
          case 5: ustavki();              break;             // низ уставки
          case 2:   read_eprom_DS();                         // считываем адреса датчиков из памяти
                    read_Ust();                              // считываем из памяти уставку температуры куба
                    avto = true;                             // при настройке регулятора всегда автомат
                    lcd.cursor();
                    set_PID();            break;             // влево режим настройки PID
          case 3: state = 0; stop_ = true; break;            // select   режим полного останова      
       };                                                    // switch
      butPush = 0; 
  };  

  if(state == 0)                                             // апарат был выключен автоматически т.е. нужно начинать процесс с начала
  {                                                          // сюда попадаем если апарат выключился и reset_нул контроллер
    lcd.print("    THE END       ");  
    lcd.setCursor(0,1);                                      // первая строка
    lcd.print("Br - ");  lcd.print(cikl_BR);
    lcd.setCursor(9,1); 
    lcd.print("CC - ");  lcd.print(cikl_CC); 

    do 
     {
       wdt_reset();                                          // сбрасываем вачдог чтобы не было резета 
       Serial.print("end");                                  // маркер окончания процесса
       delay(1000);
       Serial.flush();
     }            
    while(analogRead(butPin)>1000);                          // ждём нажатия кнопки
    butPin = 0;                                              // сброс признака нжатия кнопки
    state = 1;                                               // отмечаем что апарат в процессе работы
    EEPROM.write(129,state);                                 // статус запоминаем
    EEPROM.write(156,false);                                 // запоминаем признак "головы ещё не отобраны"
    golova = 0;                                              // сбрасываем счётчик голов на случай если апарат не был выключен из сети
    lcd.clear();    
    while(digitalRead(15)==1)                                // клапан сработан, ждём слива голов
      {
        tone(buzzer, 1000); lcd.print("  KLAPAN ERROR"); delay(1000);
        noTone(buzzer);     lcd.clear();                 delay(1000);
         wdt_reset();
      };
  };
  read_eprom_DS();                                           // считываем адреса датчиков из памяти
  read_Ust();                                                // считываем из памяти уставку температуры куба
  power = EEPROM.read(130);                                  // чтение значения заданной мощности из ЕЕПРОМ
  if(power > 100) power = 80;                                // если не корректное значение в EEPROM то выставляем 40%
  golova_bool = EEPROM.read(156);                            // признак отбора голов
};
//----------------------------------------------------------*---------------------------------------------------------------------------
void loop()                                                  // главный цикл. Когда программа доходит до конца, выполнение переходит к этой строке
{
 read_DS18B20();                                             // читаем значения температур с датчиков
 displey(button());
 butPush = 0;
 RS232();
 if(stop_ == true){T[0] = 88; T[1] = 45; T[2] = 80; T[3] = 68;}// режим тест T[0]-т.браги, T[1]-т.охладителя, T[2]-т.дефлегматора, T[3]-т.выхода
 wdt_reset();                                                // сброс сторожевого таймера   
 if(braga) ustavka_t = U[0];                                 // уставка отключения по браге
 else      ustavka_t = U[2];                                 // уставка отключения по сс
 if(T[0] > ustavka_t)				             // превышение уставки U[0]-т.браги(конец процесса)
  {
    EEPROM.write(129,0);                                     // статус 0 - признак окончания процесса запоминаем
    tone(buzzer, 1500); delay(1000); tone(buzzer, 1000); delay(1000);// музыка
    tone(buzzer,  800); delay(1000); tone(buzzer,  600); delay(1000); 
    wdt_reset();
    tone(buzzer, 400);  delay(1000); noTone(buzzer); 
    statistka();
   // resetFunc();                                             // резет контроллера с переходом на "start"
   asm volatile ("jmp 0x0000");
  };
 avtomatic();  
 displey(0);
};
//-----------------------------------------------------------------*-------------------------------------------------------------------
void RS232()
{
 if(Serial.available()>0)
   {
     delay (50);                                                    // чтобы успел прийти весь запрос
     for (n=0; n < 4; n++)  c_comand[n] = (char)Serial.read();
     if(Crc8(c_comand, 3) == c_comand[3])                           // проверка контрольной суммы
      {
        if(c_comand[0] == 117)
         {
            if      (c_comand[1] == 122)  rs232_zadanie();          // 'z' задание
            else if (c_comand[1] == 98)   rs232_braga();            // 'b' брага/спирт
            else if((c_comand[1] == 114)&&(c_comand[2] == 49))asm volatile ("jmp 0x0000");// 'r' сброс
            else if (c_comand[1] == 102)   rs232_formula();         // 'f' применить формулу
            else if (c_comand[1] == 112)  {EEPROM.write(158,c_comand[2]);  Kp = EEPROM.read(158);}// Kp
            else if (c_comand[1] == 105)  {EEPROM.write(160,c_comand[2]);  Ki = EEPROM.read(160);}// Ki
            else if (c_comand[1] == 100)  {EEPROM.write(162,c_comand[2]);  Kd = EEPROM.read(162);}// Kd            
            else if((c_comand[1] == 109)&&(c_comand[2] == 49))      // m запомнить задание 
              {
               int Result = zadanie*100;
               EEPROM.write(60,Result/1000);
               Result = Result%1000;
               EEPROM.write(61,Result/100);
               Result = Result%100;
               EEPROM.write(62,Result/10); 
             }
         }
      };
     Serial.flush(); 
   }; 
};
//-----------------------------------------------------------------*-------------------------------------------------------------------
void rs232_braga()                                                  // установка брага\спирт из порта
{
 switch(c_comand[2])
  {  
    case  48: braga = true;  break;
    case  49: braga = false; break;
 }; 
 EEPROM.write(164,braga);                                           // запись режима в ЕЕПРОМ 
 if(braga) formula = EEPROM.read(166);                              // применение формулы согласно запоиненному состоянию
 else      formula = EEPROM.read(168);
};
//-----------------------------------------------------------------*-------------------------------------------------------------------
void rs232_zadanie()                                                // управление заданием из порта
{
 switch(c_comand[2])
  {  
    case  48: zadanie = zadanie - 0.25; break;
    case  49: zadanie = zadanie + 0.25; break;
 };            
};
 //-----------------------------------------------------------------*-------------------------------------------------------------------
void rs232_formula()                                                // управление механизмами из порта
{
 switch(c_comand[2])
  {  
    case  48: formula = false;
              if(braga) EEPROM.write(166,0); else EEPROM.write(168,0);
              zadanie = EEPROM.read(60) *10 + EEPROM.read(61) + EEPROM.read(62)*0.1;// восстанавливаем задание из памяти после ухода с формулы
              break;
    case  49: formula = true;
              if(braga) EEPROM.write(166,1); else EEPROM.write(168,1);   
              break;
 };  
};
 //-----------------------------------------------------------------*-------------------------------------------------------------------
void set_PID()
{
 metka:
 read_DS18B20();                                                     // читаем значения температур с датчиков
                                          
 avtomatic(); 
 wdt_reset();                                                        // сброс сторожевого таймера   
 
 lcd.setCursor(0,0);  lcd.print("P"); lcd.print(Kp);
 lcd.setCursor(5,0);  lcd.print("I"); lcd.print(Ki);       
 lcd.setCursor(10,0); lcd.print("D"); lcd.print(Kd); 
 lcd.setCursor(14,0); lcd.print(zadanie,0);
       
 lcd.setCursor(0,1);  lcd.print(Kp_,0);     lcd.print("  ");
 lcd.setCursor(4,1);  lcd.print(Ki_,0);     lcd.print("  ");
 lcd.setCursor(8,1);  lcd.print(Kd_,0);     lcd.print("  ");  
 lcd.setCursor(12,1); lcd.print(delta_T,1);
  
 switch(butPush)
   {
    case 3: lcd.clear(); lcd.print("WRITE COEFFICIENT"); delay(2000);EEPROM.write(158,Kp); EEPROM.write(160,Ki); EEPROM.write(162,Kd); lcd.clear(); break;                                       // select - управление режимом редактирования и курсором
    case 2: if(cur_poz < 4) break; cur_poz = cur_poz - 5; lcd.setCursor(cur_poz,0); break;    // кнопка влево
    case 4: if(cur_poz > 9) break; cur_poz = cur_poz + 5; lcd.setCursor(cur_poz,0); break;    // кнопка вправо
    case 1: switch(cur_poz)                                  // вверх
              {
                case 1:  if(Kp == 50) break;  Kp ++; break;  // пропорциг\ональная
                case 6:  if(Ki == 30) break;  Ki ++; break;  // интегральная
                case 11: if(Kd == 100) break;  Kd ++; break; // дифференциальная
              } break;
        case 5:  switch(cur_poz)                             // вниз
              {
                case 1:  if(Kp == 0) break; Kp --; break;    // пропорциг\ональная
                case 6:  if(Ki == 0) break; Ki --; break;    // интегральная
                case 11: if(Kd == 0) break; Kd --; break;    // дифференциальная
              } break;
   };
 lcd.setCursor(cur_poz,0);
 butPush = 0;
 goto  metka;
};
//----------------------------------------------------------*---------------------------------------------------------------------------
void PID()
{
 if     (T[3] < 65) power_real = 100;                       // пока не нагрет дефлегматор(выход пара) мощность 100% 
 else if(!avto) {power_real = power; I = -2000;}            // мощность в ручном режиме 
 else
  {      
     T_mem = (T_mem + delta_T)/2;                           // реальная работа
     delta_T = T[0] - T[3];                                 // разность температур дефлегматора 
     if(!golova_bool) E = zadanie - T_mem + 0.7;            // если отбор голов меньше задание         
     else E = zadanie - T_mem;                              // величина рассогласования
     I = I + E;
     Ki_ = Ki*I/1000;
     if     (Ki_ > 100)  Ki_ =  110;                        // ограничения по интегральной составляющей
     else if(Ki_ < -100) Ki_ = -110;                        // ограничения по интегральной составляющей
     Kp_ = Kp*E/10;
     Kd_ = Kd*(T_mem - delta_T);
     power_float = -Kp_ - Ki_  -Kd_;                        // главная формула ПИД
 
     if     (power_float > 100) power_float = 100;          // ограничения задания регулятора в %
     else if(power_float < 0)   power_float = 0;            // ограничения задания регулятора в %
     power_real = byte(power_float);                        // перевод float в целые % задания

     if(formula) zadanie = (T[0] + 2.8)/5.6;

//zadanie = (T[0]-75)/22.8*15.7 + 9.3;  n_zad = 100; // не стирать формулу zadanie=(T[0]-75)/(97.8-75)*(23-7.3)+7.3;  97.8 Т. конца шкалы
  };
}                                                           // void PID()
//----------------------------------------------------------*---------------------------------------------------------------------------
void  avtomatic()
{
 if(T[2] < 50.0)
  {
    	digitalWrite(11, HIGH);                              // включаем форсаж  // T[2]-т.колоны меньше уставки 50г.(форсаж)
        Tdata[20] = 1;                                       // режим форсаж в порт
  }
 else
  {
        digitalWrite(11, LOW);                               // нормальный процесс форсаж выключаем 
        Tdata[20] = 0;                                       // режим форсаж в порт
  };
 if(!golova_bool) zadanie_com = zadanie + 0.7;               // задание в порт         
 else             zadanie_com = zadanie;         
  
  
 if((T[0] <= 5)||(T[1] <= 5)||                               // ошибка температуры браги или холодильника
    (T[2] <= 5)||(T[2] > 99)||                               // ошибка температуры дефлегматора
    (T[1] > U[1]))                                           // U[1]-т.холодильника велика (больше уставки)
    {
      OCR1BH=Hi(0); OCR1BL=Low(0);                           // мощность тэна "0" 
      digitalWrite(11, LOW);                                 // при ошибках выключаем форсаж
      lcd.setCursor(0,0);
      Tdata[17] = 0;                                         // мощность тэна в порт
      lcd.print("                "); 
      delay(500);
    }
  else                                        	             // нормальный процесс
    {
    //***********  отбор голов  **************************** 
      if(golova_bool == false)                               // ещё не было отбора голов
        {
          digitalWrite(12, HIGH);                            // включаем отбор голов 
          if(digitalRead(15)==1)                             // проверяем замыкание поплавка
            {
              golova++;
              if(golova > 20)
               {
                 golova_bool = true;                          // после 20 циклов программы считаем, что поплавок сработал
                 digitalWrite(12, LOW);                       // клапан выключен (нормальный режим)
                 EEPROM.write(156,true);                      // запоминаем признак "головы отобраны"
               };
            }
          else golova = 0;
        };
    //****************************************************** 
      PID();                                                 // функция регулятора нагрузки
      OCR1BH=Hi(power_real*312);  
      OCR1BL=Low(power_real*312);             
      Tdata[17] = power_real;                                // мощность тэна в порт
    };
 if(Kp_ < 0) {Tdata[28] =  byte(- Kp_); Tdata[29] = 1;}      // коэффициенты ПИД в порт
 else        {Tdata[28] =  byte(Kp_);   Tdata[29] = 0;};
 if(Ki_ < 0) {Tdata[11] = byte(- Ki_); Tdata[12] = 1;}
 else        {Tdata[11] = byte(Ki_);   Tdata[12] = 0;};
 if(Kd_ < 0) {Tdata[13] = byte(- Kd_); Tdata[14] = 1;}
 else        {Tdata[13] = byte(Kd_);   Tdata[14] = 0;};
 
 x = div(((int)(ustavka_t*10)),10);                          // уставка Т. для окончания процесса
 Tdata[15] = x.quot;
 Tdata[16] = x.rem;

 x = div(zadanie_com*10,10);                                 // деление целых чисел с остатком
 Tdata[18] = x.quot;
 Tdata[19] = x.rem; 
 
 Tdata[21] = golova_bool;                                    // режим отбор голов в порт 
 Tdata[22] = braga;                                          // брага-спирт
 Tdata[23] = formula;                                        // применение формулы 
 Tdata[24] = cikl_CC;                                        // количество циклов сырца за год
 Tdata[25] = cikl_BR;                                        // количество циклов браги за год 
 
 Tdata[30] = state;                                          // признак окончания процесса
 Tdata[31] = Kp;                                             // настроечные коэффициенты ПИД
 Tdata[32] = Ki;                                             // настроечные коэффициенты ПИД
 Tdata[33] = Kd;                                             // настроечные коэффициенты ПИД 
 Serial.write(Tdata,40);                                     // массив данных в порт  

 if(T[2]>50 && T[0]<T[2])                                    // если колонна нагрета но Т. браги меньше Т. колонны значит неисправен датчик браги
    {                                   
      tone(buzzer, 1000);
      lcd.setCursor(0,0);
      lcd.print("    "); 
      delay(500); 
      noTone(buzzer);
    }
 if(T[1]>(U[1]-5))                                           // Т.охладителя высока, предупредительная сигнализация
   {                                   
      tone(buzzer, 1000);
      lcd.setCursor(8,0);
      lcd.print("  ");   
      delay(500); 
      noTone(buzzer);
    }
};  
//----------------------------------------------------------*---------------------------------------------------------------------------
void setup_DS18B20()
{
 lcd.clear(); 
 t = 1; i = 0; n=0; m = 1;
 while (i != 1)                                             // ищем датчики 
   {
      if (ds.search(addr[n]) != 1)                          // функция поиска специальным образом выискивает первый датчик и записывает его адрес
          { // возвращет 1 если он найден. в случае, если вернет что-то не равное 1 (см. пред. строку) то поиск останавливается
            ds.reset_search();
            i = 1; 
          }
          else                                              // если что-то найдено то...
          {         
            n++;                                            // увеличиваем счетчик и ...
            TotalDS = n;                                    // говорим, что всего у нас теперь n датчиков
          }
    };
 metka1:    
 wdt_reset();  
 while(analogRead(0)<1000);                                 // ждём отпускания кнопки
 if (n==0){ lcd.setCursor(0,0); lcd.print("DS1820 Not found"); delay(1000);goto metka1;}// зависаем если нет датчиков не отпустим кнопку   
 if (n>=6){ lcd.setCursor(0,0); lcd.print("  ERROR find  ");
 lcd.setCursor(0,1); lcd.print("  DS18B20 > 5  ");delay(1000);goto metka1;}// нашли больше датчиков чем нужно 
 
 butPush = 0; 
 n = 1;
// t=4;
 metka:    
 read_DS18B20();
 wdt_reset();                                              // сброс сторожевого таймера  
 if (analogRead(0) < 1000) button ();                      // периодически проверяя не нажата ли кнопка 
 lcd.setCursor(0,0); 
 switch(t)  
   {
      case 1:   lcd.print("KUB      "); break;
      case 2:   lcd.print("OHLADITEL"); break;
      case 3:   lcd.print("KOLONNA  "); break;
      case 4:   lcd.print("OUT defl."); break;    
      case 5:   lcd.print("Vozduh   "); break;   
      default:  lcd.print("ERROR    "); break;    
   };
// lcd.print(butPush);


 
 lcd.setCursor(0,1); 
 lcd.print(m);
 lcd.print(" : ");
 lcd.print(T[m-1],1);                                      // иначе показываем текущую температуру
 switch(butPush)    
  {
      case 1: if (t<5)t++;  break;                         // кнопка вверх  if (t<5)
      case 5: if (t>1) t--;  break;                        // кнопка вниз
      case 2: if (m>1)m--;  break;                         // кнопка влево
      case 4: if (m < TotalDS) m++; break;                 // кнопка вправо
      case 3: for (i=0; i<8; i++)                          // кнопка select// всего 8 байт. В переменной m - номер датчика который надо записать
                {        
                  if (m!=0)EEPROM.write((t-1)*8+i,addr[m-1][i]);
                };
              lcd.setCursor(0,1); 
              lcd.print("Saved to EEPROM"); 
              tone(buzzer, 1000); 
              delay(1000); 
              noTone(buzzer);
              lcd.setCursor(0,1); 
              lcd.print("              ");
   };
 lcd.setCursor(11,0); lcd.print("FIND");     
 lcd.setCursor(14,1); lcd.print(TotalDS, DEC);
 butPush = 0;
 goto metka;
}
//----------------------------------------------------------*---------------------------------------------------------------------------
void ustavki()
{
 byte cursor_ust;                                            // установка курсора для устаок
 byte kursor;
 boolean cursor_vert;                                        // установка курсора для строки
 read_Ust();                                                 // считываем из памяти уставку температуры куба
 metka:
 wdt_reset();                                                // сброс сторожевого таймера 
 
 lcd.setCursor(cursor_ust, cursor_vert);
 lcd.print("     ");                                         //мигание курсора
 delay(50); 
 lcd.setCursor(0,1); lcd.print("HOLODILNIK "); lcd.print(U[1]);// уставка Т.охладителя
 //lcd.setCursor(0,0); lcd.print("BRAGA      "); lcd.print(U[0]);   // уставка Т.браги

 delay(300);  
 if (analogRead(0) < 1000)  button ();                       // периодически проверяя не нажата ли кнопка 

 switch(butPush)                                             // круговое переключение по уставкам "select"
  {
    case 3: if(kursor <4){kursor++;} else {kursor = 0;};
           switch(kursor)
             {
                case 1:  cursor_vert = false; cursor_ust = 6;  break;
                case 2:  cursor_vert = true;  cursor_ust = 0;  break;
                case 3:  cursor_vert = true;  cursor_ust = 6;  break;
                case 0:  cursor_vert = false; cursor_ust = 0;  break;
             } break;
    case 1: switch(kursor)
             {
           /*     case 0: ust_time_on_1   = ust_time_on_1  + 10;  break;
                case 1: ust_time_on_2   = ust_time_on_2  + 10;  break; 
                case 2: ust_time_off_1  = ust_time_off_1 + 10;  break; 
                case 3: ust_time_off_2  = ust_time_off_2 + 10;  break;*/
             } break;
    case 5: switch(kursor)
             {/*
                case 0: ust_time_on_1   = ust_time_on_1  - 10;  break;
                case 1: ust_time_on_2   = ust_time_on_2  - 10;  break;
                case 2: ust_time_off_1  = ust_time_off_1 - 10;  break;
                case 3: ust_time_off_2  = ust_time_off_2 - 10;  break;*/
             } break;
    case 4: lcd.clear(); lcd.print(" WRITE USTAWKI");
            
          // EEPROM.write(160,U[1]); 
           // EEPROM.write(162,U[0]);
            delay(2000); lcd.clear();
            break;
  }; 
 butPush = 0;
 goto metka;
};
//----------------------------------------------------------*---------------------------------------------------------------------------
void read_DS18B20()
{
  ds.reset();                                                // опрос датчиков начинается со сброса линии
  ds.write(0xCC,1);                                          // пропуск ROM - этим мы говорим "Внимание всем!" Следующую команду выполняют все устройства (если конечно их тип это позволяет)
  ds.write(0x44,1);                                          // запускаем конвертацию температуры

  for( n = 1; n < 90; n++)                                   // ждем 900 мс... (время необходимое датчикам чтобы преобразовать температуру)
  { 
   delay(10);            
   if(analogRead(butPin)<1000&&butRel){button();}
   else butRel=1;
  };
  for( n = 0; n < 5 ; n++)                                   // Цикл от 0 до 5 - по числу датчиков ( шт)
  {   
    ds.reset();                                              // начинаем считывать температуры, обмен начинается со сброса
    ds.select(addr[n]);                                      // выбираем нужный (по порядку) адрес датчика, после этой команды до след. сброса отвечать нам будет только выбранный датчик
    ds.write(0xBE);                                          // команда на считывание ОЗУ датчика
    for (i = 0; i < 9; i++) { data[i] = ds.read();}          // читаем с линии 9 байт
    Tp[n] = float((data[1] << 8) + data[0])/16;              // значение температуры в первых 2-х байтах. Высчитываем температуру команда float приводит тип byte (полученный от датчика) к типу с плавающей точкой
    if (Tp[n] != 85) {T[n]=Tp[n];} 
    //else { T[n]=Tp[n];}                                    // при глюке датчика (обычно при переключениях выдача температуры 85 град не приводила к переходу на другой шаг программы, возьмем предыдущее значение
    Tdata[n*2] = data[0];                                    // формирование температур датчиков для порта
    Tdata[n*2+1] = data[1];
  };
}
//----------------------------------------------------------*---------------------------------------------------------------------------
void statistik_viuver()
{
 lcd.clear(); lcd.setCursor(0,0);                           // первая строка
                                     
 lcd.print("Br 2014 --- ");  lcd.print(EEPROM.read(152));
 lcd.setCursor(0,1);                                        // вторая строка
 lcd.print("CC 2014 --- ");  lcd.print(EEPROM.read(154)); 
 
 metka:
 delay(3000);
 wdt_reset();                                               //  сброс сторожевого таймера
 goto metka; 
}  
//----------------------------------------------------------*---------------------------------------------------------------------------
void statistka()
{
 if(braga)  EEPROM.write(152,EEPROM.read(152) + 1);          // считаем циклы выгонки браги
 else EEPROM.write(154,EEPROM.read(154) + 1);                // считаем циклы выгонки сырца
}  
//----------------------------------------------------------*---------------------------------------------------------------------------
int button()                                                // подпрограмма считывания кнопок
{                
  delay(15);                                                // задержка для устранения дребезга контактов
  val = analogRead(0);                                      // читаем АЦП порта кнопок (значение от 0 до 1023)
  if      (val > (butval[5]-butsens) && val < (butval[5]+butsens))  butPush = 5;  // определяем какая кнопка нажата  
  else if (val > (butval[4]-butsens) && val < (butval[4]+butsens))  butPush = 4;  // аналогично для остальных
  else if (val > (butval[3]-butsens) && val < (butval[3]+butsens))  butPush = 3;
  else if (val > (butval[2]-butsens) && val < (butval[2]+butsens))  butPush = 2;
  else if (val > (butval[1]-butsens) && val < (butval[1]+butsens))  butPush = 1; 
  butRel=0;                                                 // эта переменная нужна для проверки в главной программе
  return butPush;                                           // возвращаем значение нажатой кнопки
}    
//----------------------------------------------------------*---------------------------------------------------------------------------
byte read_eprom_DS()                                        // программа считывает адреса датчиков из памяти
{              
  for (n=0; n<5; n++) {                                     // у нас она "заточена" на 4 адреса, потому и цикл до 3
    for (i=0; i<8; i++) {                                   // в адресе 8 байт
      addr[n][i] = EEPROM.read(n*8+i);                      // читаем байт 8 * номер датчика + номер байта
    }
  }
  return 0;
}
//----------------------------------------------------------*---------------------------------------------------------------------------
byte read_Ust(void)                                         // считываем из памяти уставку температуры куба
{
 U[0] = EEPROM.read(125) *10 + EEPROM.read(126) + EEPROM.read(127)*0.1;
 if((U[0] > 99) || (U[0] < 91)) U[0] = 98;               // в случае некорректной уставки восстановим её

 U[2] = EEPROM.read(132) *10 + EEPROM.read(133) + EEPROM.read(134)*0.1;  // уставка спирта-сырца
 if((U[2] > 98) || (U[2] < 90)) U[2] = 95.0;               // в случае некорректной уставки восстановим её  
  
 zadanie = EEPROM.read(60) *10 + EEPROM.read(61) + EEPROM.read(62)*0.1;
 if((zadanie > 24) || (zadanie < 10)) zadanie = 16.5;      // в случае некорректной уставки восстановим её

 return 0;
}
//----------------------------------------------------------*---------------------------------------------------------------------------
void displey(int butPush)                                   // вывод на дисплей
{  
 lcd.setCursor(0,0);                                        // показываем все температуры      
 lcd.print(T[0],1);                                         // выводим температуру куба
 lcd.setCursor(4,0);                                        // ставим курсор посередине первой строки
 lcd.print("h");                                            // Печатаем "H:"
 lcd.print(byte(T[1]));                                     // cвыводим температуру холодильника
 lcd.print(" ");          
 if(avto){lcd.print(power_real); lcd.print("% ");}          // выводим % реальной нагрузки
 else lcd.print("R   ");

 Tt = T[0]-T[3];
 if(Tt <10)lcd.setCursor(12,0); 
 else lcd.setCursor(13,0);  lcd.print(" "); 
 lcd.print(Tt);                                             // выводим разность температур выхода дефлегматора          
 lcd.setCursor(15,0);  
 if (formula){lcd.print("F");}
 else{lcd.print("X");};  

 lcd.setCursor(0,1);                                        // 
 lcd.print(ustavka_t,1);                                    // отображаем уставку т. по окончанию процесса
 lcd.setCursor(4,1);                                        // далее аналогично
 lcd.print("k");
 lcd.print(byte(T[2]));                                     // выводим температуру колонны 
 lcd.print(" ");
 lcd.print(power);                                          // выводим % нагрузки
 lcd.print("%");             
 lcd.setCursor(14,1); 
 lcd.print(byte(T[4]));                                     // 
 lcd.setCursor(12,1);  
 if (braga){lcd.print("B");}
 else{lcd.print("C");};   

 lcd.setCursor(edit_position,1);                            // Установим курсор для редактирования

 switch(butPush)
      {
      case 3:                                               // select - управление режимом редактирования и курсором
        if(edit_mode == 0)                                  // включаем курсор и режим редактирования
          {  
            razr = 3;
            edit_position = 3;
            lcd.cursor();
            edit_mode = 1;
          }
        else
          {
           if(braga)
             {
               lcd.noCursor();
               edit_mode = 0;
               int Result = (U[0])*100;
               EEPROM.write(125,Result/1000);
               Result = Result%1000;
               EEPROM.write(126,Result/100);
               Result = Result%100;
               EEPROM.write(127,Result/10);
             }
            else
             {
               lcd.noCursor();
               edit_mode = 0;
               int Result = (U[2])*100;
               EEPROM.write(132,Result/1000);
               Result = Result%1000;
               EEPROM.write(133,Result/100);
               Result = Result%100;
               EEPROM.write(134,Result/10);               
             };
           read_Ust();                                       // подтверждаем корректность записи уставки повторным чтением
        };       
        break;
      case 2: 
        if(edit_mode == 1)                                   //если нажата кнопка влево
        { 
          if(razr > 1) razr--;
          switch(razr)
            {
              case 1: edit_position = 0; break;
              case 2: edit_position = 1; break;                                                            
              case 3: edit_position = 3; break;                                      
            }
        }
        else
        {
          if (avto) avto = false;                             // переключение режимов автомат\ручное
          else      avto = true;
          EEPROM.write(150,avto);                             // запись режима в ЕЕПРОМ
          cikl = 0;                                           // сброс счётчика цикла    
          power_real = power;                                 // присваивем знчение мощности ручного режима втоматическому
        };
        break;
      case 4:                                                 //если нажата кнопка вправо
        if(edit_mode == 1)                               
        {
          if(razr < 3) razr++;         
          switch(razr)
            {                   
              case 1: edit_position = 0; break;                 
              case 2: edit_position = 1; break;                         
              case 3: edit_position = 3; break;                               
            };
        }
        else
        {
          if(braga) { braga = false; }                      // переключение режимов брага\спирт
          else      { braga = true;  }
          EEPROM.write(164,braga);                          // запись режима в ЕЕПРОМ    

          if(braga) formula = EEPROM.read(166);             // применение формулы 
          else      formula = EEPROM.read(168);
        };
        break;
      case 1: 
        if(edit_mode == 1)                                  //если нажата кнопка вверх
        { 
          if(braga)
            {          
              if(razr == scel) U[0]+=10; 
              else if(razr == cel)  U[0]+=1;  
              else if(razr == des)  U[0]+=0.1;
            }
          else
           {
              if(razr == scel) U[2]+=10; 
              else if(razr == cel)  U[2]+=1;  
              else if(razr == des)  U[2]+=0.1;              
            };
        }
        else
        {
          if(power <= 95)
          {
            power = power + 5;
            EEPROM.write(130,power);                        // запись заданной мощности в ЕЕПРОМ
          }
          else power = 100;
        };  
        break;
      case 5: 
        if(edit_mode == 1)                                  //если нажата кнопка вниз
        { 
          if(braga)
            {    
              if(razr == scel) U[0]-=10; 
              else if(razr == cel)  U[0]-=1;  
              else if(razr == des)  U[0]-=0.1;
            }
          else
          {
              if(razr == scel) U[2]-=10; 
              else if(razr == cel)  U[2]-=1;  
              else if(razr == des)  U[2]-=0.1;            
          };
        }
        else
        {
          if(power > 4)
          {
            power = power - 5;
            EEPROM.write(130,power);                         // запись заданной мощности в ЕЕПРОМ
          }
          else power = 0;
        };  
        break;
      };                                                     // switch(butPush)
    };                                                       // void displey(int butPush) 
//----------------------------------------------------------*---------------------------------------------------------------------------
unsigned char Crc8(unsigned char *pcBlock, unsigned int len) // функция расчёта CRC8
{
    unsigned char crc = 0xFF;
    unsigned int i;
    while (len--)
    {
        crc ^= *pcBlock++;
        for (i = 0; i < 8; i++)
        crc = crc & 0x80 ? (crc << 1) ^ 0x31 : crc << 1;
    }
    return crc;
};
//-----------------------------------------------------------------*-------------------------------------------------------------------
